// Code generated by gowrap. DO NOT EDIT.
// template: ../../assets/templates/middleware/access_log.tmpl
// gowrap: http://github.com/hexdigest/gowrap

package middleware

//go:generate gowrap gen -p git.perx.ru/perxis/perxis-go/images -i Images -t ../../assets/templates/middleware/access_log.tmpl -o access_logging_middleware.go -l ""

import (
	"context"
	"time"

	"git.perx.ru/perxis/perxis-go/images"
	"git.perx.ru/perxis/perxis-go/pkg/auth"
	"git.perx.ru/perxis/perxis-go/pkg/files"
	"go.uber.org/zap"
)

// accessLoggingMiddleware implements images.Images that is instrumented with logging
type accessLoggingMiddleware struct {
	logger *zap.Logger
	next   images.Images
}

// AccessLoggingMiddleware instruments an implementation of the images.Images with simple logging
func AccessLoggingMiddleware(logger *zap.Logger) Middleware {
	return func(next images.Images) images.Images {
		return &accessLoggingMiddleware{
			next:   next,
			logger: logger,
		}
	}
}

func (m *accessLoggingMiddleware) Get(ctx context.Context, source *files.File, opts *images.GetOptions) (result *files.File, err error) {
	begin := time.Now()

	m.logger.Debug("Get.Request",
		zap.Reflect("principal", auth.GetPrincipal(ctx)),
		zap.Reflect("source", source),
		zap.Reflect("opts", opts),
	)

	result, err = m.next.Get(ctx, source, opts)

	m.logger.Debug("Get.Response",
		zap.Duration("time", time.Since(begin)),
		zap.Reflect("result", result),
		zap.Error(err),
	)

	return result, err
}
